<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<form class="mt-4 mx-3 ls-form">

  <label [innerText]="messages.USER_PRIVILEGES_LABEL"></label>

  <div class="w-100 btn-group btn-group-toggle">

    <ng-template #unavailableInTenantModeTooltip>
      <span [innerText]="!!tenantId ? messages.ONLY_AVAILABLE_IN_TENANTLESS : messages.ONLY_AVAILABLE_IN_TENANTS"></span>
    </ng-template>

    <ng-container *ngFor="let privilege of orderedUserPrivilegeList; let i = index">

      <input
        [id]="'privilege_' + i"
        [checked]="modifiedUser.privilege === privilege"
        [(ngModel)]="modifiedUser.privilege"
        [disabled]="isPrivilegeSelectionDisabled(privilege)"
        [value]="privilege"
        class="btn-check"
        type="radio"
        name="privileges"
        autocomplete="off">

      <label
        [for]="'privilege_' + i"
        [innerText]="privilege | privilegeName"
        [ngbTooltip]="unavailableInTenantModeTooltip"
        [disableTooltip]="!isPrivilegeSelectionDisabled(privilege)"
        [ngClass]="{
            'btn-outline-primary': (modifiedUser.privilege !== privilege),
            'btn-primary': (modifiedUser.privilege === privilege),
            'disabled': isPrivilegeSelectionDisabled(privilege),
            'custom-radio-button-disabled': isPrivilegeSelectionDisabled(privilege)
          }"
        class="btn">
      </label>
    </ng-container>


  </div>

  <div
    *ngIf="(modifiedUser.privilege === userPrivilegeEnum.TenantAdmin) && !tenantId"
    class="my-4">

    <label [innerText]="messages.ADMINISTER_TENANTS"></label>

    <div class="d-flex flex-row">
      <app-search-bar
        class="search-input"
        (debouncedKeyup)="onTenantSearchKeyUp($event)"
        [placeholder]="commonMessages.SEARCH_TENANT">
      </app-search-bar>
    </div>

    <app-double-list
      [leftColumnHeader]="messages.TENANTS_LIST"
      [rightColumnHeader]="messages.ASSOCIATED_TENANTS"
      tintColor="blue"
      [retrieveCandidateElementsFn]="requestTenantFn"
      [stringifyElementFn]="stringifyNamedElementFn"
      [selectedElements]="modifiedUser.administeredTenants"
      #tenantDoubleListComponent>
    </app-double-list>
  </div>

  <div
    *ngIf="(modifiedUser.privilege === userPrivilegeEnum.FunctionalAdmin) && !!tenantId"
    class="my-4">

    <label [innerText]="messages.ADMINISTER_DESKS"></label>

    <div class="d-flex flex-row">
      <app-search-bar
        class="long-search-input"
        (debouncedKeyup)="onDeskSearchKeyUp($event)"
        [placeholder]="commonMessages.SEARCH_DESK_ADMIN">
      </app-search-bar>
    </div>

    <app-double-list
      [leftColumnHeader]="commonMessages.DESK_LIST"
      [rightColumnHeader]="messages.ADMINISTERED_DESKS"
      tintColor="blue"
      [retrieveCandidateElementsFn]="requestDesksFn"
      [stringifyElementFn]="stringifyNamedElementFn"
      [selectedElements]="modifiedUser.administeredDesks"
      #deskDoubleListComponent>
    </app-double-list>
  </div>

</form>
